Index: /palm/trunk/UTIL/inifor/src/inifor_grid.f90
===================================================================
--- /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3865)
+++ /palm/trunk/UTIL/inifor/src/inifor_grid.f90	(revision 3866)
@@ -1281,220 +1301,220 @@
 !> grid : Grid variable to be initialized.
 !------------------------------------------------------------------------------!
-    SUBROUTINE init_grid_definition(kind, xmin, xmax, ymin, ymax,              &
-                                    x0, y0, z0, nx, ny, nz, z, zw, grid, ic_mode)
-        CHARACTER(LEN=*), INTENT(IN)           ::  kind
-        CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  ic_mode
-        INTEGER, INTENT(IN)                    ::  nx, ny, nz
-        REAL(dp), INTENT(IN)                   ::  xmin, xmax, ymin, ymax
-        REAL(dp), INTENT(IN)                   ::  x0, y0, z0
-        REAL(dp), INTENT(IN), TARGET, OPTIONAL ::  z(:)
-        REAL(dp), INTENT(IN), TARGET, OPTIONAL ::  zw(:)
-        TYPE(grid_definition), INTENT(INOUT)   ::  grid
-
-        grid % nx = nx
-        grid % ny = ny
-        grid % nz = nz
-
-        grid % lx = xmax - xmin
-        grid % ly = ymax - ymin
-
-        grid % x0 = x0
-        grid % y0 = y0
-        grid % z0 = z0
-
-        SELECT CASE( TRIM(kind) )
-
-        CASE('boundary')
-
-           IF (.NOT.PRESENT(z))  THEN
-              message = "z has not been passed but is required for 'boundary' grids"
-              CALL inifor_abort('init_grid_definition', message)
-           ENDIF
-
-           ALLOCATE( grid % x(0:nx) )
-           CALL linspace(xmin, xmax, grid % x)
-
-           ALLOCATE( grid % y(0:ny) )
-           CALL linspace(ymin, ymax, grid % y)
-
-           grid % z => z
-
-!
-!--        Allocate neighbour indices and weights
-           IF (TRIM(ic_mode) .NE. 'profile')  THEN
-              ALLOCATE( grid % kk(0:nx, 0:ny, 1:nz, 2) )
-              grid % kk(:,:,:,:) = -1
-
-              ALLOCATE( grid % w_verti(0:nx, 0:ny, 1:nz, 2) )
-              grid % w_verti(:,:,:,:) = 0.0_dp
-           ENDIF
-        
-        CASE('boundary intermediate')
-
-           ALLOCATE( grid % x(0:nx) )
-           CALL linspace(xmin, xmax, grid % x)
-
-           ALLOCATE( grid % y(0:ny) )
-           CALL linspace(ymin, ymax, grid % y)
-
-           ALLOCATE( grid % clon(0:nx, 0:ny), grid % clat(0:nx, 0:ny)  )
-
-           CALL rotate_to_cosmo(                                               &
-              phir = project( grid % y, y0, EARTH_RADIUS ) ,                   & ! = plate-carree latitude
-              lamr = project( grid % x, x0, EARTH_RADIUS ) ,                   & ! = plate-carree longitude
-              phip = phi_cn, lamp = lambda_cn,                                 &
-              phi  = grid % clat,                                              &
-              lam  = grid % clon,                                              &
-              gam  = gam                                                       &
-           )
-
-!
-!--        Allocate neighbour indices and weights
-           ALLOCATE( grid % ii(0:nx, 0:ny, 4),                                 &
-                     grid % jj(0:nx, 0:ny, 4) )
-           grid % ii(:,:,:)   = -1
-           grid % jj(:,:,:)   = -1
-
-           ALLOCATE( grid % w_horiz(0:nx, 0:ny, 4) )
-           grid % w_horiz(:,:,:)   = 0.0_dp
-        
-!
-!--     This mode initializes a Cartesian PALM-4U grid and adds the
-!--     corresponding latitudes and longitudes of the rotated pole grid.
-        CASE('palm')
-
-           IF (.NOT.PRESENT(z))  THEN
-              message = "z has not been passed but is required for 'palm' grids"
-              CALL inifor_abort('init_grid_definition', message)
-           ENDIF
-
-           IF (.NOT.PRESENT(zw))  THEN
-              message = "zw has not been passed but is required for 'palm' grids"
-              CALL inifor_abort('init_grid_definition', message)
-           ENDIF
-
-           grid % name(1) = 'x and lon'
-           grid % name(2) = 'y and lat'
-           grid % name(3) = 'z'
-
-!
-!--        TODO: Remove use of global dx, dy, dz variables. Consider
-!--        TODO: associating global x,y, and z arrays.
-           ALLOCATE( grid % x(0:nx),   grid % y(0:ny) )
-           ALLOCATE( grid % xu(1:nx),  grid % yv(1:ny) )
-           CALL linspace(xmin + 0.5_dp* dx, xmax - 0.5_dp* dx, grid % x)
-           CALL linspace(ymin + 0.5_dp* dy, ymax - 0.5_dp* dy, grid % y)
-           grid % z => z
-           CALL linspace(xmin +  dx, xmax -  dx, grid % xu)
-           CALL linspace(ymin +  dy, ymax -  dy, grid % yv)
-           grid % zw => zw
-
-           grid % depths => depths
-
-!
-!--        Allocate neighbour indices and weights
-           IF (TRIM(ic_mode) .NE. 'profile')  THEN
-              ALLOCATE( grid % kk(0:nx, 0:ny, 1:nz, 2) )
-              grid % kk(:,:,:,:) = -1
-
-              ALLOCATE( grid % w_verti(0:nx, 0:ny, 1:nz, 2) )
-              grid % w_verti(:,:,:,:) = 0.0_dp
-           ENDIF
-
-        CASE('palm intermediate')
-
-           grid % name(1) = 'x and lon'
-           grid % name(2) = 'y and lat'
-           grid % name(3) = 'interpolated hhl or hfl'
-
-!
-!--        TODO: Remove use of global dx, dy, dz variables. Consider
-!--        TODO: associating global x,y, and z arrays.
-           ALLOCATE( grid % x(0:nx),   grid % y(0:ny) )
-           ALLOCATE( grid % xu(1:nx),  grid % yv(1:ny) )
-           CALL linspace(xmin + 0.5_dp*dx, xmax - 0.5_dp*dx, grid % x)
-           CALL linspace(ymin + 0.5_dp*dy, ymax - 0.5_dp*dy, grid % y)
-           CALL linspace(xmin + dx, xmax - dx, grid % xu)
-           CALL linspace(ymin + dy, ymax - dy, grid % yv)
-
-           grid % depths => depths
-
-!
-!--        Allocate rotated-pole coordinates, clon is for (c)osmo-de (lon)gitude
-           ALLOCATE( grid % clon(0:nx, 0:ny),   grid % clat(0:nx, 0:ny)  )
-           ALLOCATE( grid % clonu(1:nx, 0:ny),  grid % clatu(1:nx, 0:ny) )
-           ALLOCATE( grid % clonv(0:nx, 1:ny),  grid % clatv(0:nx, 1:ny) )
-
-!
-!--        Compute rotated-pole coordinates of...
-!--        ... PALM-4U centres
-           CALL rotate_to_cosmo(                                               &
-              phir = project( grid % y, y0, EARTH_RADIUS ) , & ! = plate-carree latitude
-              lamr = project( grid % x, x0, EARTH_RADIUS ) , & ! = plate-carree longitude
-              phip = phi_cn, lamp = lambda_cn,                                 &
-              phi  = grid % clat,                                              &
-              lam  = grid % clon,                                              &
-              gam  = gam                                                       &
-           )
-
-!
-!--        ... PALM-4U u winds
-           CALL rotate_to_cosmo(                                               &
-              phir = project( grid % y,  y0, EARTH_RADIUS ), & ! = plate-carree latitude
-              lamr = project( grid % xu, x0, EARTH_RADIUS ), & ! = plate-carree longitude
-              phip = phi_cn, lamp = lambda_cn,                                 &
-              phi  = grid % clatu,                                             &
-              lam  = grid % clonu,                                             &
-              gam  = gam                                                       &
-           )
-
-!
-!--        ... PALM-4U v winds
-           CALL rotate_to_cosmo(                                               &
-              phir = project( grid % yv, y0, EARTH_RADIUS ), & ! = plate-carree latitude
-              lamr = project( grid % x,  x0, EARTH_RADIUS ), & ! = plate-carree longitude
-              phip = phi_cn, lamp = lambda_cn,                                 &
-              phi  = grid % clatv,                                             &
-              lam  = grid % clonv,                                             &
-              gam  = gam                                                       &
-           )
-
-!
-!--        Allocate neighbour indices and weights
-           ALLOCATE( grid % ii(0:nx, 0:ny, 4),                                 &
-                     grid % jj(0:nx, 0:ny, 4) )
-           grid % ii(:,:,:)   = -1
-           grid % jj(:,:,:)   = -1
-
-           ALLOCATE( grid % w_horiz(0:nx, 0:ny, 4) )
-           grid % w_horiz(:,:,:)   = 0.0_dp
-
-        CASE('cosmo-de')
-           grid % name(1) = 'rlon'         ! of COMSO-DE cell centres (scalars)
-           grid % name(2) = 'rlat'         ! of COMSO-DE cell centres (scalars)
-           grid % name(3) = 'height'
-
-           ALLOCATE( grid % lon(0:nx),   grid % lat(0:ny)  )
-           ALLOCATE( grid % lonu(0:nx),  grid % latv(0:ny) )
-
-           CALL linspace(xmin, xmax, grid % lon)
-           CALL linspace(ymin, ymax, grid % lat)
-           grid % lonu(:) = grid % lon + 0.5_dp * (grid % lx / grid % nx)
-           grid % latv(:) = grid % lat + 0.5_dp * (grid % ly / grid % ny)
-
-!
-!--        Point to heights of half levels (hhl) and compute heights of full
-!--        levels (hfl) as arithmetic averages
-           grid % hhl => hhl
-           grid % hfl => hfl
-           grid % depths => depths
-
-        CASE DEFAULT
-            message = "Grid kind '" // TRIM(kind) // "' is not recognized."
-            CALL inifor_abort('init_grid_definition', message)
-
-        END SELECT
-
-    END SUBROUTINE init_grid_definition
+ SUBROUTINE init_grid_definition(kind, xmin, xmax, ymin, ymax,              &
+                                 x0, y0, z0, nx, ny, nz, z, zw, grid, ic_mode)
+    CHARACTER(LEN=*), INTENT(IN)           ::  kind
+    CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  ic_mode
+    INTEGER, INTENT(IN)                    ::  nx, ny, nz
+    REAL(wp), INTENT(IN)                   ::  xmin, xmax, ymin, ymax
+    REAL(wp), INTENT(IN)                   ::  x0, y0, z0
+    REAL(wp), INTENT(IN), TARGET, OPTIONAL ::  z(:)
+    REAL(wp), INTENT(IN), TARGET, OPTIONAL ::  zw(:)
+    TYPE(grid_definition), INTENT(INOUT)   ::  grid
+
+    grid%nx = nx
+    grid%ny = ny
+    grid%nz = nz
+
+    grid%lx = xmax - xmin
+    grid%ly = ymax - ymin
+
+    grid%x0 = x0
+    grid%y0 = y0
+    grid%z0 = z0
+
+    SELECT CASE( TRIM(kind) )
+
+       CASE('boundary')
+       
+          IF (.NOT.PRESENT(z))  THEN
+             message = "z has not been passed but is required for 'boundary' grids"
+             CALL inifor_abort('init_grid_definition', message)
+          ENDIF
+       
+          ALLOCATE( grid%x(0:nx) )
+          CALL linspace(xmin, xmax, grid%x)
+       
+          ALLOCATE( grid%y(0:ny) )
+          CALL linspace(ymin, ymax, grid%y)
+       
+          grid%z => z
+       
+!      
+!--       Allocate neighbour indices and weights
+          IF (TRIM(ic_mode) .NE. 'profile')  THEN
+             ALLOCATE( grid%kk(0:nx, 0:ny, 1:nz, 2) )
+             grid%kk(:,:,:,:) = -1
+       
+             ALLOCATE( grid%w_verti(0:nx, 0:ny, 1:nz, 2) )
+             grid%w_verti(:,:,:,:) = 0.0_wp
+          ENDIF
+       
+       CASE('boundary intermediate')
+       
+          ALLOCATE( grid%x(0:nx) )
+          CALL linspace(xmin, xmax, grid%x)
+       
+          ALLOCATE( grid%y(0:ny) )
+          CALL linspace(ymin, ymax, grid%y)
+       
+          ALLOCATE( grid%clon(0:nx, 0:ny), grid%clat(0:nx, 0:ny)  )
+       
+          CALL rotate_to_cosmo(                                               &
+             phir = project( grid%y, y0, EARTH_RADIUS ) ,                   & ! = plate-carree latitude
+             lamr = project( grid%x, x0, EARTH_RADIUS ) ,                   & ! = plate-carree longitude
+             phip = phi_cn, lamp = lambda_cn,                                 &
+             phi  = grid%clat,                                              &
+             lam  = grid%clon,                                              &
+             gam  = gam                                                       &
+          )
+       
+!      
+!--       Allocate neighbour indices and weights
+          ALLOCATE( grid%ii(0:nx, 0:ny, 4),                                 &
+                    grid%jj(0:nx, 0:ny, 4) )
+          grid%ii(:,:,:)   = -1
+          grid%jj(:,:,:)   = -1
+       
+          ALLOCATE( grid%w_horiz(0:nx, 0:ny, 4) )
+          grid%w_horiz(:,:,:)   = 0.0_wp
+       
+!      
+!--    This mode initializes a Cartesian PALM-4U grid and adds the
+!--    corresponding latitudes and longitudes of the rotated pole grid.
+       CASE('palm')
+       
+          IF (.NOT.PRESENT(z))  THEN
+             message = "z has not been passed but is required for 'palm' grids"
+             CALL inifor_abort('init_grid_definition', message)
+          ENDIF
+       
+          IF (.NOT.PRESENT(zw))  THEN
+             message = "zw has not been passed but is required for 'palm' grids"
+             CALL inifor_abort('init_grid_definition', message)
+          ENDIF
+       
+          grid%name(1) = 'x and lon'
+          grid%name(2) = 'y and lat'
+          grid%name(3) = 'z'
+       
+!      
+!--       TODO: Remove use of global dx, dy, dz variables. Consider
+!--       TODO: associating global x,y, and z arrays.
+          ALLOCATE( grid%x(0:nx),   grid%y(0:ny) )
+          ALLOCATE( grid%xu(1:nx),  grid%yv(1:ny) )
+          CALL linspace(xmin + 0.5_wp* dx, xmax - 0.5_wp* dx, grid%x)
+          CALL linspace(ymin + 0.5_wp* dy, ymax - 0.5_wp* dy, grid%y)
+          grid%z => z
+          CALL linspace(xmin +  dx, xmax -  dx, grid%xu)
+          CALL linspace(ymin +  dy, ymax -  dy, grid%yv)
+          grid%zw => zw
+       
+          grid%depths => depths
+       
+!      
+!--       Allocate neighbour indices and weights
+          IF (TRIM(ic_mode) .NE. 'profile')  THEN
+             ALLOCATE( grid%kk(0:nx, 0:ny, 1:nz, 2) )
+             grid%kk(:,:,:,:) = -1
+       
+             ALLOCATE( grid%w_verti(0:nx, 0:ny, 1:nz, 2) )
+             grid%w_verti(:,:,:,:) = 0.0_wp
+          ENDIF
+       
+       CASE('palm intermediate')
+       
+          grid%name(1) = 'x and lon'
+          grid%name(2) = 'y and lat'
+          grid%name(3) = 'interpolated hhl or hfl'
+       
+!      
+!--       TODO: Remove use of global dx, dy, dz variables. Consider
+!--       TODO: associating global x,y, and z arrays.
+          ALLOCATE( grid%x(0:nx),   grid%y(0:ny) )
+          ALLOCATE( grid%xu(1:nx),  grid%yv(1:ny) )
+          CALL linspace(xmin + 0.5_wp*dx, xmax - 0.5_wp*dx, grid%x)
+          CALL linspace(ymin + 0.5_wp*dy, ymax - 0.5_wp*dy, grid%y)
+          CALL linspace(xmin + dx, xmax - dx, grid%xu)
+          CALL linspace(ymin + dy, ymax - dy, grid%yv)
+       
+          grid%depths => depths
+       
+!      
+!--       Allocate rotated-pole coordinates, clon is for (c)osmo-de (lon)gitude
+          ALLOCATE( grid%clon(0:nx, 0:ny),   grid%clat(0:nx, 0:ny)  )
+          ALLOCATE( grid%clonu(1:nx, 0:ny),  grid%clatu(1:nx, 0:ny) )
+          ALLOCATE( grid%clonv(0:nx, 1:ny),  grid%clatv(0:nx, 1:ny) )
+       
+!      
+!--       Compute rotated-pole coordinates of...
+!--       ... PALM-4U centres
+          CALL rotate_to_cosmo(                                               &
+             phir = project( grid%y, y0, EARTH_RADIUS ) , & ! = plate-carree latitude
+             lamr = project( grid%x, x0, EARTH_RADIUS ) , & ! = plate-carree longitude
+             phip = phi_cn, lamp = lambda_cn,                                 &
+             phi  = grid%clat,                                              &
+             lam  = grid%clon,                                              &
+             gam  = gam                                                       &
+          )
+       
+!      
+!--       ... PALM-4U u winds
+          CALL rotate_to_cosmo(                                               &
+             phir = project( grid%y,  y0, EARTH_RADIUS ), & ! = plate-carree latitude
+             lamr = project( grid%xu, x0, EARTH_RADIUS ), & ! = plate-carree longitude
+             phip = phi_cn, lamp = lambda_cn,                                 &
+             phi  = grid%clatu,                                             &
+             lam  = grid%clonu,                                             &
+             gam  = gam                                                       &
+          )
+       
+!      
+!--       ... PALM-4U v winds
+          CALL rotate_to_cosmo(                                               &
+             phir = project( grid%yv, y0, EARTH_RADIUS ), & ! = plate-carree latitude
+             lamr = project( grid%x,  x0, EARTH_RADIUS ), & ! = plate-carree longitude
+             phip = phi_cn, lamp = lambda_cn,                                 &
+             phi  = grid%clatv,                                             &
+             lam  = grid%clonv,                                             &
+             gam  = gam                                                       &
+          )
+       
+!      
+!--       Allocate neighbour indices and weights
+          ALLOCATE( grid%ii(0:nx, 0:ny, 4),                                 &
+                    grid%jj(0:nx, 0:ny, 4) )
+          grid%ii(:,:,:)   = -1
+          grid%jj(:,:,:)   = -1
+       
+          ALLOCATE( grid%w_horiz(0:nx, 0:ny, 4) )
+          grid%w_horiz(:,:,:)   = 0.0_wp
+       
+       CASE('cosmo-de')
+          grid%name(1) = 'rlon'         ! of COMSO-DE cell centres (scalars)
+          grid%name(2) = 'rlat'         ! of COMSO-DE cell centres (scalars)
+          grid%name(3) = 'height'
+       
+          ALLOCATE( grid%lon(0:nx),   grid%lat(0:ny)  )
+          ALLOCATE( grid%lonu(0:nx),  grid%latv(0:ny) )
+       
+          CALL linspace(xmin, xmax, grid%lon)
+          CALL linspace(ymin, ymax, grid%lat)
+          grid%lonu(:) = grid%lon + 0.5_wp * (grid%lx / grid%nx)
+          grid%latv(:) = grid%lat + 0.5_wp * (grid%ly / grid%ny)
+       
+!      
+!--       Point to heights of half levels (hhl) and compute heights of full
+!--       levels (hfl) as arithmetic averages
+          grid%hhl => hhl
+          grid%hfl => hfl
+          grid%depths => depths
+       
+       CASE DEFAULT
+           message = "Grid kind '" // TRIM(kind) // "' is not recognized."
+           CALL inifor_abort('init_grid_definition', message)
+
+    END SELECT
+
+ END SUBROUTINE init_grid_definition
 
 
@@ -1527,148 +1547,147 @@
 !> avg_grid : averagin grid to be initialized
 !------------------------------------------------------------------------------!
-    SUBROUTINE init_averaging_grid(avg_grid, cosmo_grid, x, y, z, z0,          &
-       lonmin, lonmax, latmin, latmax, kind, name)
-
-       TYPE(grid_definition), INTENT(INOUT) ::  avg_grid
-       TYPE(grid_definition), INTENT(IN)    ::  cosmo_grid
-       REAL(dp), INTENT(IN)                 ::  x, y, z0
-       REAL(dp), INTENT(IN), TARGET         ::  z(:)
-       REAL(dp), INTENT(IN)                 ::  lonmin !< lower longitude bound of the averaging grid region [COSMO rotated-pole rad]
-       REAL(dp), INTENT(IN)                 ::  lonmax !< upper longitude bound of the averaging grid region [COSMO rotated-pole rad]
-       REAL(dp), INTENT(IN)                 ::  latmin !< lower latitude bound of the averaging grid region [COSMO rotated-pole rad]
-       REAL(dp), INTENT(IN)                 ::  latmax !< lower latitude bound of the averaging grid region [COSMO rotated-pole rad]
-
-       CHARACTER(LEN=*), INTENT(IN)         ::  kind
-       CHARACTER(LEN=*), INTENT(IN)         ::  name
-
-       LOGICAL                              ::  level_based_averaging
-
-       ALLOCATE( avg_grid % x(1) )
-       ALLOCATE( avg_grid % y(1) )
-       avg_grid % x(1) = x
-       avg_grid % y(1) = y
-       avg_grid % z => z
-       avg_grid % z0 = z0
-
-       avg_grid % nz = SIZE(z, 1)
-
-       ALLOCATE( avg_grid % lon(2) )
-       ALLOCATE( avg_grid % lat(2) )
-       avg_grid % lon(1:2) = (/lonmin, lonmax/)
-       avg_grid % lat(1:2) = (/latmin, latmax/)
-
-       avg_grid % kind = TRIM(kind)
-       avg_grid % name(1) = TRIM(name)
-
-!
-!--    Find and store COSMO columns that fall into the coordinate range
-!--    given by avg_grid % clon, % clat
-       CALL get_cosmo_averaging_region(avg_grid, cosmo_grid)
-
-       ALLOCATE (avg_grid % kkk(avg_grid % n_columns, avg_grid % nz, 2) )
-       ALLOCATE (avg_grid % w(avg_grid % n_columns, avg_grid % nz, 2) )
-!
-!--    Compute average COSMO levels in the averaging region
-       SELECT CASE(avg_grid % kind)
+ SUBROUTINE init_averaging_grid(avg_grid, cosmo_grid, x, y, z, z0,          &
+    lonmin, lonmax, latmin, latmax, kind, name)
+
+    TYPE(grid_definition), INTENT(INOUT) ::  avg_grid
+    TYPE(grid_definition), INTENT(IN)    ::  cosmo_grid
+    REAL(wp), INTENT(IN)                 ::  x, y, z0
+    REAL(wp), INTENT(IN), TARGET         ::  z(:)
+    REAL(wp), INTENT(IN)                 ::  lonmin !< lower longitude bound of the averaging grid region [COSMO rotated-pole rad]
+    REAL(wp), INTENT(IN)                 ::  lonmax !< upper longitude bound of the averaging grid region [COSMO rotated-pole rad]
+    REAL(wp), INTENT(IN)                 ::  latmin !< lower latitude bound of the averaging grid region [COSMO rotated-pole rad]
+    REAL(wp), INTENT(IN)                 ::  latmax !< lower latitude bound of the averaging grid region [COSMO rotated-pole rad]
+
+    CHARACTER(LEN=*), INTENT(IN)         ::  kind
+    CHARACTER(LEN=*), INTENT(IN)         ::  name
+
+    LOGICAL                              ::  level_based_averaging
+
+    ALLOCATE( avg_grid%x(1) )
+    ALLOCATE( avg_grid%y(1) )
+    avg_grid%x(1) = x
+    avg_grid%y(1) = y
+    avg_grid%z => z
+    avg_grid%z0 = z0
+
+    avg_grid%nz = SIZE(z, 1)
+
+    ALLOCATE( avg_grid%lon(2) )
+    ALLOCATE( avg_grid%lat(2) )
+    avg_grid%lon(1:2) = (/lonmin, lonmax/)
+    avg_grid%lat(1:2) = (/latmin, latmax/)
+
+    avg_grid%kind = TRIM(kind)
+    avg_grid%name(1) = TRIM(name)
+
+!
+!-- Find and store COSMO columns that fall into the coordinate range
+!-- given by avg_grid%clon, %clat
+    CALL get_cosmo_averaging_region(avg_grid, cosmo_grid)
+
+    ALLOCATE (avg_grid%kkk(avg_grid%n_columns, avg_grid%nz, 2) )
+    ALLOCATE (avg_grid%w(avg_grid%n_columns, avg_grid%nz, 2) )
+!
+!-- Compute average COSMO levels in the averaging region
+    SELECT CASE(avg_grid%kind)
 
        CASE('scalar', 'u', 'v')
-          avg_grid % cosmo_h => cosmo_grid % hfl
+          avg_grid%cosmo_h => cosmo_grid%hfl
 
        CASE('w')
-          avg_grid % cosmo_h => cosmo_grid % hhl
+          avg_grid%cosmo_h => cosmo_grid%hhl
 
        CASE DEFAULT
-          message = "Averaging grid kind '" // TRIM(avg_grid % kind) // &
+          message = "Averaging grid kind '" // TRIM(avg_grid%kind) // &
                     "' is not supported. Use 'scalar', 'u', or 'v'."
           CALL inifor_abort('get_cosmo_averaging_region', message)
 
-       END SELECT
-
-!
-!--    For level-besed averaging, compute average heights
-       !level_based_averaging = ( TRIM(mode) == 'level' )
-       level_based_averaging = ( TRIM(cfg % averaging_mode) == 'level' )
-       IF (level_based_averaging)  THEN
-          ALLOCATE(avg_grid % h(1,1,SIZE(avg_grid % cosmo_h, 3)) )
+    END SELECT
+
+!
+!-- For level-besed averaging, compute average heights
+    level_based_averaging = ( TRIM(cfg%averaging_mode) == 'level' )
+    IF (level_based_averaging)  THEN
+       ALLOCATE(avg_grid%h(1,1,SIZE(avg_grid%cosmo_h, 3)) )
  
-          CALL average_2d(avg_grid % cosmo_h, avg_grid % h(1,1,:),             &
-                          avg_grid % iii, avg_grid % jjj)
-
-       ENDIF
-
-!
-!--    Compute vertical weights and neighbours
-       CALL find_vertical_neighbours_and_weights_average(                      &
-          avg_grid, level_based_averaging                                      &
-       )
-
-    END SUBROUTINE init_averaging_grid
-
-
-    SUBROUTINE get_cosmo_averaging_region(avg_grid, cosmo_grid)
-       TYPE(grid_definition), INTENT(INOUT)         ::  avg_grid
-       TYPE(grid_definition), TARGET, INTENT(IN)    ::  cosmo_grid
-
-       REAL(dp), DIMENSION(:), POINTER              ::  cosmo_lon, cosmo_lat
-       REAL(dp)                                     ::  dlon, dlat
-
-       INTEGER ::  i, j, imin, imax, jmin, jmax, l, nx, ny
-
-
-       SELECT CASE( TRIM(avg_grid % kind) )
+       CALL average_2d(avg_grid%cosmo_h, avg_grid%h(1,1,:),             &
+                       avg_grid%iii, avg_grid%jjj)
+
+    ENDIF
+
+!
+!-- Compute vertical weights and neighbours
+    CALL find_vertical_neighbours_and_weights_average(                      &
+       avg_grid, level_based_averaging                                      &
+    )
+
+ END SUBROUTINE init_averaging_grid
+
+
+ SUBROUTINE get_cosmo_averaging_region(avg_grid, cosmo_grid)
+    TYPE(grid_definition), INTENT(INOUT)         ::  avg_grid
+    TYPE(grid_definition), TARGET, INTENT(IN)    ::  cosmo_grid
+
+    REAL(wp), DIMENSION(:), POINTER              ::  cosmo_lon, cosmo_lat
+    REAL(wp)                                     ::  dlon, dlat
+
+    INTEGER ::  i, j, imin, imax, jmin, jmax, l, nx, ny
+
+
+    SELECT CASE( TRIM(avg_grid%kind) )
 
        CASE('scalar', 'w')
-          cosmo_lon => cosmo_grid % lon
-          cosmo_lat => cosmo_grid % lat
+          cosmo_lon => cosmo_grid%lon
+          cosmo_lat => cosmo_grid%lat
 
        CASE('u')
-          cosmo_lon => cosmo_grid % lonu
-          cosmo_lat => cosmo_grid % lat
+          cosmo_lon => cosmo_grid%lonu
+          cosmo_lat => cosmo_grid%lat
 
        CASE('v')
-          cosmo_lon => cosmo_grid % lon
-          cosmo_lat => cosmo_grid % latv
+          cosmo_lon => cosmo_grid%lon
+          cosmo_lat => cosmo_grid%latv
 
        CASE DEFAULT
-          message = "Averaging grid kind '" // TRIM(avg_grid % kind) // &
+          message = "Averaging grid kind '" // TRIM(avg_grid%kind) // &
                     "' is not supported. Use 'scalar', 'u', or 'v'."
           CALL inifor_abort('get_cosmo_averaging_region', message)
 
-       END SELECT
-
-!
-!--    FIXME: make dlon, dlat parameters of the grid_defintion type
-       dlon = cosmo_lon(1) - cosmo_lon(0)
-       dlat = cosmo_lat(1) - cosmo_lat(0)
-
-       imin = FLOOR  ( (avg_grid % lon(1) - cosmo_lon(0)) / dlon )
-       imax = CEILING( (avg_grid % lon(2) - cosmo_lon(0)) / dlon )
-
-       jmin = FLOOR  ( (avg_grid % lat(1) - cosmo_lat(0)) / dlat )
-       jmax = CEILING( (avg_grid % lat(2) - cosmo_lat(0)) / dlat )
-       
-       message = "Grid " // TRIM(avg_grid % name(1)) // " averages over " // &
-                 TRIM(str(imin)) // " <= i <= " // TRIM(str(imax)) //          &
-                 " and " //                                                    &
-                 TRIM(str(jmin)) // " <= j <= " // TRIM(str(jmax))
-       CALL report( 'get_cosmo_averaging_region', message )
-
-       nx = imax - imin + 1
-       ny = jmax - jmin + 1
-       avg_grid % n_columns = nx * ny
-
-       ALLOCATE( avg_grid % iii(avg_grid % n_columns),                         &
-                 avg_grid % jjj(avg_grid % n_columns) )
-
-       l = 0
-       DO j = jmin, jmax
-       DO i = imin, imax
-          l = l + 1
-          avg_grid % iii(l) = i
-          avg_grid % jjj(l) = j
-       ENDDO
-       ENDDO
-
-    END SUBROUTINE get_cosmo_averaging_region
+    END SELECT
+
+!
+!-- FIXME: make dlon, dlat parameters of the grid_defintion type
+    dlon = cosmo_lon(1) - cosmo_lon(0)
+    dlat = cosmo_lat(1) - cosmo_lat(0)
+
+    imin = FLOOR  ( (avg_grid%lon(1) - cosmo_lon(0)) / dlon )
+    imax = CEILING( (avg_grid%lon(2) - cosmo_lon(0)) / dlon )
+
+    jmin = FLOOR  ( (avg_grid%lat(1) - cosmo_lat(0)) / dlat )
+    jmax = CEILING( (avg_grid%lat(2) - cosmo_lat(0)) / dlat )
+    
+    message = "Grid " // TRIM(avg_grid%name(1)) // " averages over " // &
+              TRIM(str(imin)) // " <= i <= " // TRIM(str(imax)) //          &
+              " and " //                                                    &
+              TRIM(str(jmin)) // " <= j <= " // TRIM(str(jmax))
+    CALL report( 'get_cosmo_averaging_region', message )
+
+    nx = imax - imin + 1
+    ny = jmax - jmin + 1
+    avg_grid%n_columns = nx * ny
+
+    ALLOCATE( avg_grid%iii(avg_grid%n_columns),                         &
+              avg_grid%jjj(avg_grid%n_columns) )
+
+    l = 0
+    DO  j = jmin, jmax
+    DO  i = imin, imax
+       l = l + 1
+       avg_grid%iii(l) = i
+       avg_grid%jjj(l) = j
+    ENDDO
+    ENDDO
+
+ END SUBROUTINE get_cosmo_averaging_region
 
 
